# tap-swisscom-mip

`tap-swisscom-mip` is a Singer tap for SwisscomMIP.

Built with the [Meltano Tap SDK](https://sdk.meltano.com) for Singer Taps.

## Installation

Install from PyPi:

```bash
pipx install tap-swisscom-mip
```

Install from GitHub:

```bash
pipx install git+https://gitlab.com/cividi/devops/tap-swisscom-mip.git@main
```

## Configuration

### Accepted Config Options

| Setting              | Required |                       Default                       | Description                                                                                                                                 |
| :------------------- | :------: | :-------------------------------------------------: | :------------------------------------------------------------------------------------------------------------------------------------------ |
| auth_token           |   True   |                        None                         | The current bearer token to authenticate against the API service                                                                            |
| area_id              |  False   |                        None                         | Area ID to replicate                                                                                                                        |
| period_start         |  False   |                        None                         | Monday (YYYY-MM-DD) for period begin                                                                                                        |
| api_url              |  False   | https://insights-server-prod.scapp.swisscom.com/api | The base url for the API service                                                                                                            |
| stream_maps          |  False   |                        None                         | Config object for stream maps capability. For more information check out [Stream Maps](https://sdk.meltano.com/en/latest/stream_maps.html). |
| stream_map_config    |  False   |                        None                         | User-defined config values to be used within map expressions.                                                                               |
| flattening_enabled   |  False   |                        None                         | 'True' to enable schema flattening and automatically expand nested properties.                                                              |
| flattening_max_depth |  False   |                        None                         | The max depth to flatten schemas.                                                                                                           |

A full list of supported settings and capabilities is available by running: `tap-swisscom-mip --about`

A full list of supported settings and capabilities for this
tap is available by running:

```bash
tap-swisscom-mip --about
```

### Configure using environment variables

This Singer tap will automatically import any environment variables within the working directory's
`.env` if the `--config=ENV` is provided, such that config values will be considered if a matching
environment variable is set either in the terminal context or in the `.env` file.

### Source Authentication and Authorization

Set `auth_token` to bearer token (without `Bearer`), which needs to be obtained after manually logging into https://mip.swisscom.ch via browser dev tools.

## Usage

You can easily run `tap-swisscom-mip` by itself or in a pipeline using [Meltano](https://meltano.com/).

### Executing the Tap Directly

```bash
tap-swisscom-mip --version
tap-swisscom-mip --help
tap-swisscom-mip --config CONFIG --discover > ./catalog.json
```

## Developer Resources

Follow these instructions to contribute to this project.

### Initialize your Development Environment

```bash
pipx install poetry
poetry install
```

### Create and Run Tests

Create tests within the `tap_swisscom_mip/tests` subfolder and
then run:

```bash
poetry run pytest
```

You can also test the `tap-swisscom-mip` CLI interface directly using `poetry run`:

```bash
poetry run tap-swisscom-mip --help
```

### Testing with [Meltano](https://www.meltano.com)

_**Note:** This tap will work in any Singer environment and does not require Meltano.
Examples here are for convenience and to streamline end-to-end orchestration scenarios._

Next, install Meltano (if you haven't already) and any needed plugins:

```bash
# Install meltano
pipx install meltano
# Initialize meltano within this directory
cd tap-swisscom-mip
meltano install
```

Now you can test and orchestrate using Meltano:

```bash
# Test invocation:
meltano invoke tap-swisscom-mip --version
# OR run a test `elt` pipeline:
meltano elt tap-swisscom-mip target-jsonl
```

### SDK Dev Guide

See the [dev guide](https://sdk.meltano.com/en/latest/dev_guide.html) for more instructions on how to use the SDK to
develop your own taps and targets.
